import * as iam from 'aws-cdk-lib/aws-iam';
import { Construct } from 'constructs';
/**
 * (deprecated) Properties for a SamlProvider.
 *
 * @deprecated use `SamlProviderProps` from `aws-cdk-lib/aws-iam`
 */
export interface SamlIdentityProviderProps {
    /**
     * (deprecated) A name for the SAML identity provider.
     *
     * @default - derived for the node's unique id
     * @deprecated
     */
    readonly name?: string;
    /**
     * (deprecated) An XML document generated by an identity provider (IdP) that supports SAML 2.0.
     *
     * The document includes the issuer's name, expiration information, and keys that
     * can be used to validate the SAML authentication response (assertions) that are
     * received from the IdP. You must generate the metadata document using the identity
     * management software that is used as your organization's IdP.
     *
     * @deprecated
     */
    readonly metadataDocument: string;
}
/**
 * (deprecated) Create a SAML identity provider.
 *
 * @deprecated use `SamlProvider` from `aws-cdk-lib/aws-iam`
 */
export declare class SamlIdentityProvider extends Construct {
    /**
     * (deprecated) The ARN of the SAML identity provider.
     *
     * @deprecated
     */
    readonly samlIdentityProviderArn: string;
    /**
     * @deprecated
     */
    constructor(scope: Construct, id: string, props: SamlIdentityProviderProps);
}
/**
 * (deprecated) Principal entity that represents a SAML federated identity provider.
 *
 * @deprecated use `SamlPrincipal` from `aws-cdk-lib/aws-iam`
 */
export declare class SamlFederatedPrincipal extends iam.FederatedPrincipal {
    /**
     * @deprecated
     */
    constructor(identityProvider: SamlIdentityProvider);
}
